﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using Taxi.WebApi.Storage;

namespace Taxi.WebApi.Migrations
{
    [DbContext(typeof(TaxiContext))]
    [Migration("20191117143403_Initial")]
    partial class Initial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:PostgresExtension:uuid-ossp", ",,")
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn)
                .HasAnnotation("ProductVersion", "3.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("Taxi.Domain.Address", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("BuildingNumber")
                        .HasColumnType("text");

                    b.Property<Guid?>("PositionId")
                        .HasColumnType("uuid");

                    b.Property<string>("SpecificAddress")
                        .HasColumnType("text");

                    b.Property<Guid?>("StreetId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("PositionId");

                    b.HasIndex("StreetId");

                    b.ToTable("Address");
                });

            modelBuilder.Entity("Taxi.Domain.Board", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CarId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("DriverId")
                        .HasColumnType("uuid");

                    b.Property<DateTime?>("End")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid?>("PositionId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("Start")
                        .HasColumnType("timestamp without time zone");

                    b.HasKey("Id");

                    b.HasIndex("CarId");

                    b.HasIndex("DriverId");

                    b.HasIndex("PositionId");

                    b.ToTable("Board");
                });

            modelBuilder.Entity("Taxi.Domain.Car", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Mark")
                        .HasColumnType("text");

                    b.Property<string>("Model")
                        .HasColumnType("text");

                    b.Property<string>("Number")
                        .HasColumnType("text");

                    b.Property<Guid?>("OwnerId")
                        .HasColumnType("uuid");

                    b.Property<int>("TarifRank")
                        .HasColumnType("integer");

                    b.Property<Guid?>("TypeId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("Year")
                        .HasColumnType("timestamp without time zone");

                    b.HasKey("Id");

                    b.HasIndex("OwnerId");

                    b.HasIndex("TypeId");

                    b.ToTable("Car");
                });

            modelBuilder.Entity("Taxi.Domain.CarCarOption", b =>
                {
                    b.Property<Guid?>("CarId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CarOptionId")
                        .HasColumnType("uuid");

                    b.HasKey("CarId", "CarOptionId");

                    b.HasIndex("CarOptionId");

                    b.ToTable("CarCarOption");
                });

            modelBuilder.Entity("Taxi.Domain.CarOption", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("CarOption");

                    b.HasData(
                        new
                        {
                            Id = new Guid("b98ab410-bdce-4aea-9300-48f41371873c"),
                            Name = "Детское сиденье"
                        },
                        new
                        {
                            Id = new Guid("c2d045b7-483d-49fc-9133-f5f8fe5058ca"),
                            Name = "Домашнее животное"
                        },
                        new
                        {
                            Id = new Guid("4166cfc2-46b2-44a3-9fa2-c21b4d0f12d8"),
                            Name = "Доставка"
                        });
                });

            modelBuilder.Entity("Taxi.Domain.CarType", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("CarType");

                    b.HasData(
                        new
                        {
                            Id = new Guid("0281c710-6e53-4d49-a219-73a27a8d3d5f"),
                            Name = "Седан"
                        },
                        new
                        {
                            Id = new Guid("1bafafbd-5ec7-4dbb-8d7d-a1b1b43ba866"),
                            Name = "Универсал"
                        },
                        new
                        {
                            Id = new Guid("a245f9a1-fa31-4552-bf88-4e4689a0b861"),
                            Name = "Хетчбек"
                        },
                        new
                        {
                            Id = new Guid("c3862077-3574-4142-98c9-0aab05c0dd0a"),
                            Name = "Фургон"
                        });
                });

            modelBuilder.Entity("Taxi.Domain.City", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.Property<Guid?>("RegionId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("RegionId");

                    b.ToTable("City");
                });

            modelBuilder.Entity("Taxi.Domain.Client", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("UserId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("Client");
                });

            modelBuilder.Entity("Taxi.Domain.ClientAddress", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("AddressId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("ClientId")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("AddressId");

                    b.HasIndex("ClientId");

                    b.ToTable("ClientAddress");
                });

            modelBuilder.Entity("Taxi.Domain.Contact", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Email")
                        .HasColumnType("text");

                    b.Property<string>("FirstName")
                        .HasColumnType("text");

                    b.Property<int?>("Gender")
                        .HasColumnType("integer");

                    b.Property<string>("LastName")
                        .HasColumnType("text");

                    b.Property<string>("MiddleName")
                        .HasColumnType("text");

                    b.Property<string>("Phone")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("Contact");
                });

            modelBuilder.Entity("Taxi.Domain.Country", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("Country");
                });

            modelBuilder.Entity("Taxi.Domain.Driver", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<bool>("IsActive")
                        .HasColumnType("boolean");

                    b.Property<string>("LicenceNumber")
                        .HasColumnType("text");

                    b.Property<Guid?>("UserId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("Driver");
                });

            modelBuilder.Entity("Taxi.Domain.Order", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("BoardId")
                        .HasColumnType("uuid");

                    b.Property<double>("CalculatedAmount")
                        .HasColumnType("double precision");

                    b.Property<Guid?>("ClientId")
                        .HasColumnType("uuid");

                    b.Property<DateTime?>("End")
                        .HasColumnType("timestamp without time zone");

                    b.Property<DateTime>("Start")
                        .HasColumnType("timestamp without time zone");

                    b.Property<int>("Status")
                        .HasColumnType("integer");

                    b.Property<Guid?>("TarifId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("BoardId");

                    b.HasIndex("ClientId");

                    b.HasIndex("TarifId");

                    b.ToTable("Order");
                });

            modelBuilder.Entity("Taxi.Domain.OrderCarOption", b =>
                {
                    b.Property<Guid?>("OrderId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CarOptionId")
                        .HasColumnType("uuid");

                    b.HasKey("OrderId", "CarOptionId");

                    b.HasIndex("CarOptionId");

                    b.ToTable("OrderCarOption");
                });

            modelBuilder.Entity("Taxi.Domain.OrderCarType", b =>
                {
                    b.Property<Guid?>("OrderId")
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CarTypeId")
                        .HasColumnType("uuid");

                    b.HasKey("OrderId", "CarTypeId");

                    b.HasIndex("CarTypeId");

                    b.ToTable("OrderCarType");
                });

            modelBuilder.Entity("Taxi.Domain.Position", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<double>("Latitude")
                        .HasColumnType("double precision");

                    b.Property<double>("Longitude")
                        .HasColumnType("double precision");

                    b.HasKey("Id");

                    b.ToTable("Position");
                });

            modelBuilder.Entity("Taxi.Domain.Rate", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Comment")
                        .HasColumnType("text");

                    b.Property<Guid?>("OrderId")
                        .HasColumnType("uuid");

                    b.Property<int>("Score")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.HasIndex("OrderId");

                    b.ToTable("Rate");
                });

            modelBuilder.Entity("Taxi.Domain.Region", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CountryId")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("CountryId");

                    b.ToTable("Region");
                });

            modelBuilder.Entity("Taxi.Domain.RouteMember", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("AddressId")
                        .HasColumnType("uuid");

                    b.Property<DateTime?>("ArriveDate")
                        .HasColumnType("timestamp without time zone");

                    b.Property<Guid?>("OrderId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("AddressId");

                    b.HasIndex("OrderId");

                    b.ToTable("RouteMember");
                });

            modelBuilder.Entity("Taxi.Domain.Street", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("CityId")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("CityId");

                    b.ToTable("Street");
                });

            modelBuilder.Entity("Taxi.Domain.Tarif", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<double>("DistancePrice")
                        .HasColumnType("double precision");

                    b.Property<string>("Name")
                        .HasColumnType("text");

                    b.Property<int>("Rank")
                        .HasColumnType("integer");

                    b.Property<Guid?>("RegionId")
                        .HasColumnType("uuid");

                    b.Property<double>("TimePrice")
                        .HasColumnType("double precision");

                    b.HasKey("Id");

                    b.HasIndex("RegionId");

                    b.ToTable("Tarif");

                    b.HasData(
                        new
                        {
                            Id = new Guid("16e362be-73fc-4319-bcba-8b423c05792a"),
                            DistancePrice = 15.0,
                            Name = "Эконом",
                            Rank = 0,
                            TimePrice = 8.0
                        },
                        new
                        {
                            Id = new Guid("a5f9d4ec-0a14-4f16-95a4-7f89da5bed68"),
                            DistancePrice = 20.0,
                            Name = "Бизнес",
                            Rank = 1,
                            TimePrice = 8.0
                        },
                        new
                        {
                            Id = new Guid("764cb89f-e8e6-4174-85be-c6e7425f6a4f"),
                            DistancePrice = 25.0,
                            Name = "Люкс",
                            Rank = 2,
                            TimePrice = 10.0
                        },
                        new
                        {
                            Id = new Guid("7d929aff-0781-4b95-9590-a0c4dcb98fe5"),
                            DistancePrice = 30.0,
                            Name = "Премиум",
                            Rank = 3,
                            TimePrice = 12.0
                        });
                });

            modelBuilder.Entity("Taxi.Domain.User", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid?>("ContactId")
                        .HasColumnType("uuid");

                    b.Property<bool>("IsActive")
                        .HasColumnType("boolean");

                    b.Property<bool>("IsAdmin")
                        .HasColumnType("boolean");

                    b.Property<string>("Login")
                        .HasColumnType("text");

                    b.Property<string>("Password")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("ContactId");

                    b.ToTable("User");

                    b.HasData(
                        new
                        {
                            Id = new Guid("555537dd-aa9e-49ae-95c7-e4cbb2307fbd"),
                            IsActive = true,
                            IsAdmin = true,
                            Login = "Supervisor",
                            Password = "Supervisor"
                        });
                });

            modelBuilder.Entity("Taxi.Domain.Address", b =>
                {
                    b.HasOne("Taxi.Domain.Position", "Position")
                        .WithMany()
                        .HasForeignKey("PositionId");

                    b.HasOne("Taxi.Domain.Street", "Street")
                        .WithMany()
                        .HasForeignKey("StreetId");
                });

            modelBuilder.Entity("Taxi.Domain.Board", b =>
                {
                    b.HasOne("Taxi.Domain.Car", "Car")
                        .WithMany()
                        .HasForeignKey("CarId");

                    b.HasOne("Taxi.Domain.Driver", "Driver")
                        .WithMany()
                        .HasForeignKey("DriverId");

                    b.HasOne("Taxi.Domain.Position", "Position")
                        .WithMany()
                        .HasForeignKey("PositionId");
                });

            modelBuilder.Entity("Taxi.Domain.Car", b =>
                {
                    b.HasOne("Taxi.Domain.User", "Owner")
                        .WithMany()
                        .HasForeignKey("OwnerId");

                    b.HasOne("Taxi.Domain.CarType", "Type")
                        .WithMany()
                        .HasForeignKey("TypeId");
                });

            modelBuilder.Entity("Taxi.Domain.CarCarOption", b =>
                {
                    b.HasOne("Taxi.Domain.Car", null)
                        .WithMany("Options")
                        .HasForeignKey("CarId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Taxi.Domain.CarOption", "CarOption")
                        .WithMany()
                        .HasForeignKey("CarOptionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Taxi.Domain.City", b =>
                {
                    b.HasOne("Taxi.Domain.Region", "Region")
                        .WithMany()
                        .HasForeignKey("RegionId");
                });

            modelBuilder.Entity("Taxi.Domain.Client", b =>
                {
                    b.HasOne("Taxi.Domain.User", "User")
                        .WithMany()
                        .HasForeignKey("UserId");
                });

            modelBuilder.Entity("Taxi.Domain.ClientAddress", b =>
                {
                    b.HasOne("Taxi.Domain.Address", "Address")
                        .WithMany()
                        .HasForeignKey("AddressId");

                    b.HasOne("Taxi.Domain.Client", null)
                        .WithMany("Addresses")
                        .HasForeignKey("ClientId");
                });

            modelBuilder.Entity("Taxi.Domain.Driver", b =>
                {
                    b.HasOne("Taxi.Domain.User", "User")
                        .WithMany()
                        .HasForeignKey("UserId");
                });

            modelBuilder.Entity("Taxi.Domain.Order", b =>
                {
                    b.HasOne("Taxi.Domain.Board", "Board")
                        .WithMany()
                        .HasForeignKey("BoardId");

                    b.HasOne("Taxi.Domain.Client", "Client")
                        .WithMany()
                        .HasForeignKey("ClientId");

                    b.HasOne("Taxi.Domain.Tarif", "Tarif")
                        .WithMany()
                        .HasForeignKey("TarifId");
                });

            modelBuilder.Entity("Taxi.Domain.OrderCarOption", b =>
                {
                    b.HasOne("Taxi.Domain.CarOption", "CarOption")
                        .WithMany()
                        .HasForeignKey("CarOptionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Taxi.Domain.Order", null)
                        .WithMany("CarOptions")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Taxi.Domain.OrderCarType", b =>
                {
                    b.HasOne("Taxi.Domain.CarType", "CarType")
                        .WithMany()
                        .HasForeignKey("CarTypeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Taxi.Domain.Order", null)
                        .WithMany("CarTypes")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Taxi.Domain.Rate", b =>
                {
                    b.HasOne("Taxi.Domain.Order", "Order")
                        .WithMany()
                        .HasForeignKey("OrderId");
                });

            modelBuilder.Entity("Taxi.Domain.Region", b =>
                {
                    b.HasOne("Taxi.Domain.Country", "Country")
                        .WithMany()
                        .HasForeignKey("CountryId");
                });

            modelBuilder.Entity("Taxi.Domain.RouteMember", b =>
                {
                    b.HasOne("Taxi.Domain.Address", "Address")
                        .WithMany()
                        .HasForeignKey("AddressId");

                    b.HasOne("Taxi.Domain.Order", null)
                        .WithMany("Route")
                        .HasForeignKey("OrderId");
                });

            modelBuilder.Entity("Taxi.Domain.Street", b =>
                {
                    b.HasOne("Taxi.Domain.City", "City")
                        .WithMany()
                        .HasForeignKey("CityId");
                });

            modelBuilder.Entity("Taxi.Domain.Tarif", b =>
                {
                    b.HasOne("Taxi.Domain.Region", "Region")
                        .WithMany()
                        .HasForeignKey("RegionId");
                });

            modelBuilder.Entity("Taxi.Domain.User", b =>
                {
                    b.HasOne("Taxi.Domain.Contact", "Contact")
                        .WithMany()
                        .HasForeignKey("ContactId");
                });
#pragma warning restore 612, 618
        }
    }
}
